
	LIST P=16F876
	#include p16f876.inc
		__CONFIG 03D32h
 
;, 0
	cblock 0x20	
	CntTMR0		;C     
	CntPWM1		; 
	FRQ1Lo		;    
	FRQ1Hi		;
	Temp		;     
	Flag
	W_TEMP		; 
	STATUS_TEMP
	PCLATH_TEMP
	AD
	AD1
	AD2
	AD3
	PP
	endc

SAMPLES			EQU	.32			;-   


#define		SIN1	1	;
;   
INIT_PORTA	EQU	b'00000000'
INIT_PORTB	EQU	b'00000111'
INIT_PORTC	EQU	b'00000000'
INIT_OPTION	EQU	b'10001000'	
INIT_INTCON	EQU	b'10100000'
INIT_PIE1	EQU	b'00000000'
INIT_ADCON0	EQU	b'10000001'
INIT_ADCON1	EQU	b'10001101';
; Flag:
#define	SINUS1		Flag,0
#define	toif		INTCON,2

 	GOTO Begin

Intrp	org	0x4

	MOVWF W_TEMP 			;   
	SWAPF STATUS,W 
	CLRF STATUS 
	MOVWF STATUS_TEMP
	MOVF PCLATH, W 
	MOVWF PCLATH_TEMP
	CLRF PCLATH
	BTFSS toif
	GOTO rett
	BCF toif				;  TMR0
	decfsz CntTMR0,1		
	goto rett
	movf FRQ1Lo,0			;  
	movwf TMR0				;
	movf FRQ1Hi,0			;
	movwf CntTMR0			;
	decfsz CntPWM1,1		;  
	goto Get_Table1
	movlw SAMPLES
	movwf CntPWM1
Get_Table1

	movf CntPWM1,0			;  
	btfsc SINUS1
	call SinTable			;
	call ChangePWM1			;    


rett
	MOVF PCLATH_TEMP, W		;    
	MOVWF PCLATH
	SWAPF STATUS_TEMP,W 
	MOVWF STATUS
	SWAPF W_TEMP,F
	SWAPF W_TEMP,W
	retfie
SinTable
	clrf PCLATH
	addwf PCL,1
	nop
	retlw .128		;0
	retlw .153		;1
	retlw .177		;2
	retlw .199		;3
	retlw .218		;4
	retlw .234		;5
	retlw .245		;6
	retlw .253		;7
	retlw .255		;8
	retlw .253		;9
	retlw .245		;10
	retlw .234		;11
	retlw .218		;12
	retlw .199		;13
	retlw .177		;14
	retlw .153		;15
	retlw .128		;16
	retlw .103		;17
	retlw .80		;18
	retlw .58		;19
	retlw .38		;20
	retlw .23		;21
	retlw .11		;22
	retlw .3		;23
	retlw .1		;24
	retlw .3		;25
	retlw .11		;26
	retlw .22		;27
	retlw .38		;28
	retlw .57		;29
	retlw .79		;30
	retlw .103		;31

ChangePWM1
	movwf Temp
	bcf STATUS,C
	rrf Temp,1
	bcf CCP1CON,5
	bcf CCP1CON,4
	btfsc STATUS,C
	bsf CCP1CON,4
	bcf STATUS,C
	rrf Temp,0
	btfsc STATUS,C
	bsf CCP1CON,5
	movwf CCPR1L
	return
Begin
	CLRF	PORTA
	BSF STATUS,RP0
 	BCF STATUS,IRP
	BCF STATUS,RP1
	MOVLW INIT_PORTA
	MOVWF TRISA^80h
	MOVLW INIT_PORTB
	MOVWF TRISB^80h
	MOVLW INIT_PORTC
	MOVWF TRISC^80h
	MOVLW INIT_OPTION
	MOVWF OPTION_REG^80h
	movlw INIT_PIE1		
	movwf PIE1^80h
	clrf PIE2^80h
	movlw INIT_ADCON1	
	movwf ADCON1^80h
 	BCF STATUS,RP0
	movlw INIT_INTCON
	movwf INTCON
	movlw INIT_ADCON0	
	movwf ADCON0
				
Z10	
	BSF		PORTB,4
	CALL	PAUSE
	MOVF	PORTB,0
	MOVWF	AD1
	BTFSC	AD1,0
	GOTO	Z1
	BTFSC	AD1,1
	GOTO	Z4
	BTFSC	AD1,2
	GOTO	Z5
	BCF		PORTB,4
	CALL	PAUSE
	BSF		PORTB,5
	CALL	PAUSE
	MOVF	PORTB,0
	MOVWF	AD1
	BTFSC	AD1,0
	GOTO	Z2
	BTFSC	AD1,2
	GOTO	Z3
	BCF		PORTB,5
	CALL	PAUSE
	BSF		PORTB,6
	CALL	PAUSE
	MOVF	PORTB,0
	MOVWF	AD1
	BTFSC	AD1,0
	GOTO	Z6
	BTFSC	AD1,1
	GOTO	Z7
	BTFSC	AD1,2
	GOTO	Z8
	BCF		PORTB,6
	
	CALL	PAUSE
	GOTO	Z10

Z1	
	MOVLW	.3
	MOVWF	AD
	MOVWF	AD2
	MOVLW	.7
	MOVWF	AD3
	GOTO	ER

Z4	
	MOVLW	.14
	MOVWF	AD
	MOVWF	AD2
	MOVLW	.4
	MOVWF	AD3
	GOTO	ER

Z5	
	MOVLW	.26
	MOVWF	AD
	MOVWF	AD2
	MOVLW	.3
	MOVWF	AD3
	GOTO	ER

Z6	
	MOVLW	.39
	MOVWF	AD
	MOVWF	AD2
	MOVLW	.3
	MOVWF	AD3
	GOTO	ER

Z7	
	MOVLW	.55
	MOVWF	AD
	MOVWF	AD2
	MOVLW	.2
	MOVWF	AD3
	GOTO	ER

Z8	
	MOVLW	.71
	MOVWF	AD
	MOVWF	AD2
	MOVLW	.2
	MOVWF	AD3
	GOTO	ER

Z2	
	INCF	AD,1
	MOVF	AD,0
	MOVWF	AD2
	GOTO	ER
Z3
	CLRF	PORTA
	DECF	AD,1
	MOVF	AD,0
	MOVWF	AD2
	GOTO	ER	
	
ER	MOVF	AD3,0
	MOVWF 	FRQ1Hi
	MOVF	AD2,0
	MOVWF	PORTA
	BSF		STATUS,RP0
	MOVWF	EEADR
	BSF		EECON1,RD
	NOP
	MOVF	EEDATA,0
	BCF		STATUS,RP0
	MOVWF 	FRQ1Lo
	
	
	movlw .1			
	movwf CntPWM1 
	movlw .64		
	bsf STATUS,RP0
	movwf PR2^80h
	bcf STATUS,RP0
	movlw b'00000001'
	movwf CCPR1L
	bcf CCP1CON,5
	bsf CCP1CON,4
	movlw b'00000000'
	movwf CCPR2L
	bcf CCP2CON,5
	bsf CCP2CON,4
	movlw b'00000100'
	movwf T2CON
	movlw 0x0c
	iorwf CCP1CON,1
	movlw 0x0c
	iorwf CCP2CON,1
	bsf SINUS1
							
Z9	MOVF	PORTB,0
	MOVWF	AD1
	BTFSC	AD1,0
	GOTO	Z9
	BTFSC	AD1,1
	GOTO	Z9
	BTFSC	AD1,2
	GOTO	Z9
	GOTO	Z10				

PAUSE
	MOVLW	.100
	MOVWF	PP
ZZ	DECFSZ	PP,1
	GOTO	ZZ
	RETURN
	
	ORG		2100H
	DATA	.119,.96,.72,.142,.48,.24,.1,.164
	DATA	.185,.206,.226,.246,.24,.32,.40,.48
	DATA	.56,.64,.72,.80,.88,.16,.8,.1
	DATA	.70,.74,.78,.82,.86,.90,.94,.98
	DATA	.66,.62,.58,.54,.50,.229,.231,.233
	DATA	.235,.237,.239,.241,.242,.244,.227,.225
	DATA	.223,.221,.219,.217,.215,.74,.76,.78
	DATA	.80,.82,.84,.86,.88,.90,.72,.70
	DATA	.68,.66,.64,.62,.60,.144,.145,.146
	DATA	.147,.148,.149,.150,.151,.143,.142,.141
	DATA	.140,.139,.138,.137,.136,.133,.1,.134
	DATA	.1,.135,.1,.136,.1,.137,.1,.138
	DATA	.1,.139,.1,.140,.1,.152,.1,.153
	DATA	.1,.154,.1,.155,.1,.157,.1,.158
	DATA	.1,.159,.1,.160,.1,.161,.1,.162

	end
